/**
 * File:        AnniversaryDates.c
 * Author:      xxxxxx
 * Created:     18.09.20 
 * Last edit:   30.09.20 
 *
 * Description: Programme for finding dates of anniversary for people.
 *
 */
#include<stdio.h>
#include<stdlib.h>

int year, month, day, dayofweek = 0, daysinmonth = 0;
int calcyear = 0, calcday = 0, calcmonth = 0, calcdayofweek = 0, f1 = 1, f2 = 1, i, i2 = 1;
int main(){
// Accepting inputs from the user
    printf("Please enter the year of your birth |YYYY| : ");
    scanf("%d", &year);
    while ( year < 0){ //Confirms that year is a positive value
        printf("Year should be a positive value\n");
        printf("Please re-enter the year of your birth |YYYY|: ");
        scanf("%d", &year);
    }
    printf("Please enter the month of your birth |MM|: ");
    scanf("%d", &month);
    while ( month < 0 || month > 12){ //Confirms that month data resides in range from 1 to 12
        printf("Month should be in range from 1 to 12\n");
        printf("Please re-enter the month of your birth |MM|: ");
        scanf("%d", &month);
    }
    printf("Please enter the day of your birth |DD|: ");
    scanf("%d", &day);
    while( day < 0){
        printf("Day should be a positive value"); //Confirms that day value is positive
        printf("Please re-enter the day of your birth |DD|: ");
        scanf("%d", &day);
    }
    switch(month){ // Checks if given amount of days doesn't exceed that in given month.
    case 1:
        if( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
    case 2:
        if ( year % 4 == 0 && year % 400 == 0 && day > 29){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
        else if ( year % 4 != 0 && year % 400 != 0 && day > 28){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 3:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 4:
        if ( day > 30){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 5:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 6:
        if ( day > 30){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 7:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 8:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 9:
        if ( day > 30){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 10:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 11:
        if ( day > 30){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
   case 12:
        if ( day > 31){
            printf("You are exceeding amount of days in given month\n");
            printf("Please re-enter the day of your birth |DD|: ");
            scanf("%d", &day);
        }
    }
    printf("Please enter the day of the week when you were born |1 - 7|: ");
    scanf("%d", &dayofweek); //Asks user about the day of the week when he was born, important for defining anniversary dates
    while( dayofweek < 0 || dayofweek > 7){
        printf("Please re-enter the day of the week when you were born|1 - 7|: "); //Confirms that given day of the week resides in range from 1 to 7
        scanf("%d", &dayofweek);
    }

    calcyear = year;
    calcdayofweek = dayofweek;

    for( calcyear, i = 0; i < 50;){ // First for loop, calculates amount of years passed
        if ( calcmonth == 12){
            calcyear++;
            calcmonth = 1;
            i++; // Loops run for a period of 50 years.
        }
        for( calcmonth = 1; calcmonth < 12;){ // Second for loop, calculates amount of months passed
                if (f2 == 1){
                    calcmonth = month; // Used to begin the loop from given month.
                }
                f2++;
                if( calcmonth == 1){
                    daysinmonth = 31;
                }
                else if ( calcmonth == 2){
                    if ( calcyear % 4 == 0 && calcyear % 400 == 0){
                        daysinmonth = 29;
                    }
                    else if ( calcyear % 4 != 0 && calcyear % 400 != 0){
                        daysinmonth = 28;
                    }
                }
                else if( calcmonth == 3){
                    daysinmonth = 31;
                }
                else if( calcmonth == 4){
                    daysinmonth = 30;
                }
                else if( calcmonth == 5){
                    daysinmonth = 31;
                }
                else if( calcmonth == 6){
                    daysinmonth = 30;
                }
                else if( calcmonth == 7){
                    daysinmonth = 31;
                }
                else if( calcmonth == 8){
                    daysinmonth = 31;
                }
                else if( calcmonth == 9){
                    daysinmonth = 30;
                }
                else if( calcmonth == 10){
                    daysinmonth = 31;
                }
                else if( calcmonth == 11){
                    daysinmonth = 30;
                }
                else if( calcmonth == 12){
                    daysinmonth = 31;
                }
                if ( calcday == daysinmonth ){
                    calcday = 1;
                    calcmonth++;
                }
                for( calcday = 1, dayofweek ; calcday < daysinmonth; ){ // Third for loop, calculates amount of days passed and also stores the day of the week
                    // Catches the dates corresponding to anniversary and displays them.
                    if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 1){
                        printf(" Your next anniversary will be on the Monday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 2){
                        printf(" Your next anniversary will be on the Tuesday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 3){
                        printf(" Your next anniversary will be on the Wednesday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 4){
                        printf(" Your next anniversary will be on the Thursday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 5){
                        printf(" Your next anniversary will be on the Friday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 6){
                        printf(" Your next anniversary will be on the Saturday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    else if( calcday == day && calcmonth == month && calcyear == year + 5 * i2 && calcdayofweek == 7){
                        printf(" Your next anniversary will be on the Sunday of |%d.%d.%d|\n", calcday, calcmonth, calcyear);
                        i2++;
                    }
                    if( f1 == 1){ // Used to start loop from given day.
                        calcday = day;
                    }
                    f1++;
                    calcday++;
                    if ( calcdayofweek == 7){
                        calcdayofweek = 1;
                    }
                    calcdayofweek++;
                }
        }
    }
    return 0;
}
